WHITESPACE_MAP = {
    "\u000a": "LINE FEED",
    "\u000b": "LINE TABULATION",
    "\u000d": "CARRIAGE RETURN",
    "\u0020": "SPACE",
}

# From https://invisible-characters.com/
INVISIBLE_CHAR_MAP = {
    "\u0009": "CHARACTER TABULATION",
    "\u000a": "LINE FEED",
    "\u000b": "LINE TABULATION",
    "\u000c": "FORM FEED",
    "\u000d": "CARRIAGE RETURN",
    "\u0020": "SPACE",
    "\u00a0": "NO-BREAK SPACE",
    "\u00ad": "SOFT HYPHEN",
    "\u034f": "COMBINING GRAPHEME JOINER",
    "\u061c": "ARABIC LETTER MARK",
    "\u115f": "HANGUL CHOSEONG FILLER",
    "\u1160": "HANGUL JUNGSEONG FILLER",
    "\u17b4": "KHMER VOWEL INHERENT AQ",
    "\u17b5": "KHMER VOWEL INHERENT AA",
    "\u180b": "MONGOLIAN FREE VARIATION SELECTOR ONE",
    "\u180c": "MONGOLIAN FREE VARIATION SELECTOR TWO",
    "\u180d": "MONGOLIAN FREE VARIATION SELECTOR THREE",
    "\u180e": "MONGOLIAN VOWEL SEPARATOR",
    "\u2000": "EN QUAD",
    "\u2001": "EM QUAD",
    "\u2002": "EN SPACE",
    "\u2003": "EM SPACE",
    "\u2004": "THREE-PER-EM SPACE",
    "\u2005": "FOUR-PER-EM SPACE",
    "\u2006": "SIX-PER-EM SPACE",
    "\u2007": "FIGURE SPACE",
    "\u2008": "PUNCTUATION SPACE",
    "\u2009": "THIN SPACE",
    "\u200a": "HAIR SPACE",
    "\u200b": "ZERO WIDTH SPACE",
    "\u200c": "ZERO WIDTH NON-JOINER",
    "\u200d": "ZERO WIDTH JOINER",
    "\u200e": "LEFT-TO-RIGHT MARK",
    "\u200f": "RIGHT-TO-LEFT MARK",
    "\u202a": "LEFT-TO-RIGHT EMBEDDING",
    "\u202b": "RIGHT-TO-LEFT EMBEDDING",
    "\u202c": "POP DIRECTIONAL FORMATTING",
    "\u202d": "LEFT-TO-RIGHT OVERRIDE",
    "\u202e": "RIGHT-TO-LEFT OVERRIDE",
    "\u202f": "NARROW NO-BREAK SPACE",
    "\u205f": "MEDIUM MATHEMATICAL SPACE",
    "\u2060": "WORD JOINER",
    "\u2061": "FUNCTION APPLICATION",
    "\u2062": "INVISIBLE TIMES",
    "\u2063": "INVISIBLE SEPARATOR",
    "\u2064": "INVISIBLE PLUS",
    "\u2065": "Invisible operators - undefined",
    "\u2066": "LEFT-TO-RIGHT ISOLATE",
    "\u2067": "RIGHT-TO-LEFT ISOLATE",
    "\u2068": "FIRST STRONG ISOLATE",
    "\u2069": "POP DIRECTIONAL ISOLATE",
    "\u206a": "INHIBIT SYMMETRIC SWAPPING",
    "\u206b": "ACTIVATE SYMMETRIC SWAPPING",
    "\u206c": "INHIBIT ARABIC FORM SHAPING",
    "\u206d": "ACTIVATE ARABIC FORM SHAPING",
    "\u206e": "NATIONAL DIGIT SHAPES",
    "\u206f": "NOMINAL DIGIT SHAPES",
    "\u2800": "BRAILLE PATTERN BLANK",
    "\u3000": "IDEOGRAPHIC SPACE",
    "\u3164": "HANGUL FILLER",
    "\ufe00": "VARIATION SELECTOR-1",
    "\ufe01": "VARIATION SELECTOR-2",
    "\ufe02": "VARIATION SELECTOR-3",
    "\ufe03": "VARIATION SELECTOR-4",
    "\ufe04": "VARIATION SELECTOR-5",
    "\ufe05": "VARIATION SELECTOR-6",
    "\ufe06": "VARIATION SELECTOR-7",
    "\ufe07": "VARIATION SELECTOR-8",
    "\ufe08": "VARIATION SELECTOR-9",
    "\ufe09": "VARIATION SELECTOR-10",
    "\ufe0a": "VARIATION SELECTOR-11",
    "\ufe0b": "VARIATION SELECTOR-12",
    "\ufe0c": "VARIATION SELECTOR-13",
    "\ufe0d": "VARIATION SELECTOR-14",
    "\ufe0e": "VARIATION SELECTOR-15",
    "\ufe0f": "VARIATION SELECTOR-16",
    "\ufeff": "ZERO WIDTH NO-BREAK SPACE",
    "\uffa0": "HALFWIDTH HANGUL FILLER",
    "\ufffc": "OBJECT REPLACEMENT CHARACTER",
    "\u133fc": "EGYPTIAN HIEROGLYPH Z015B",
    "\u1d000": "GLAGOLITIC CAPITAL LETTER BUKY",
    "\u1d0f0": "GLAGOLITIC SMALL LETTER YERU",
    "\u1d100": "GLAGOLITIC CAPITAL LETTER AZU",
    "\u1d129": "GLAGOLITIC SMALL LETTER YUS",
    "\u1d130": "GLAGOLITIC CAPITAL LETTER IZHITSA",
    "\u1d13f": "GLAGOLITIC SMALL LETTER YAT",
    "\u1d140": "GLAGOLITIC CAPITAL LETTER FITA",
    "\u1d145": "GLAGOLITIC SMALL LETTER FITA",
    "\u1d150": "MUSICAL SYMBOL BEGIN BEAM",
    "\u1d159": "MUSICAL SYMBOL NULL NOTEHEAD",
    "\u1d173": "MUSICAL SYMBOL BEGIN BEAM",
    "\u1d174": "MUSICAL SYMBOL END BEAM",
    "\u1d175": "MUSICAL SYMBOL BEGIN TIE",
    "\u1d176": "MUSICAL SYMBOL END TIE",
    "\u1d177": "MUSICAL SYMBOL BEGIN SLUR",
    "\u1d178": "MUSICAL SYMBOL END SLUR",
    "\u1d179": "MUSICAL SYMBOL BEGIN PHRASE",
    "\u1d17a": "MUSICAL SYMBOL END PHRASE",
    "\ue0001": "LANGUAGE TAG",
    "\ue0020": "TAG SPACE",
    "\ue0021": "TAG EXCLAMATION MARK",
    "\ue0022": "TAG QUOTATION MARK",
    "\ue0023": "TAG NUMBER SIGN",
    "\ue0024": "TAG DOLLAR SIGN",
    "\ue0025": "TAG PERCENT SIGN",
    "\ue0026": "TAG AMPERSAND",
    "\ue0027": "TAG APOSTROPHE",
    "\ue0028": "TAG LEFT PARENTHESIS",
    "\ue0029": "TAG RIGHT PARENTHESIS",
    "\ue002a": "TAG ASTERISK",
    "\ue002b": "TAG PLUS SIGN",
    "\ue002c": "TAG COMMA",
    "\ue002d": "TAG HYPHEN-MINUS",
    "\ue002e": "TAG FULL STOP",
    "\ue002f": "TAG SOLIDUS",
    "\ue0030": "TAG DIGIT ZERO",
    "\ue0031": "TAG DIGIT ONE",
    "\ue0032": "TAG DIGIT TWO",
    "\ue0033": "TAG DIGIT THREE",
    "\ue0034": "TAG DIGIT FOUR",
    "\ue0035": "TAG DIGIT FIVE",
    "\ue0036": "TAG DIGIT SIX",
    "\ue0037": "TAG DIGIT SEVEN",
    "\ue0038": "TAG DIGIT EIGHT",
    "\ue0039": "TAG DIGIT NINE",
    "\ue003a": "TAG COLON",
    "\ue003b": "TAG SEMICOLON",
    "\ue003c": "TAG LESS-THAN SIGN",
    "\ue003d": "TAG EQUALS SIGN",
    "\ue003e": "TAG GREATER-THAN SIGN",
    "\ue003f": "TAG QUESTION MARK",
    "\ue0040": "TAG COMMERCIAL AT",
    "\ue0041": "TAG LATIN CAPITAL LETTER A",
    "\ue0042": "TAG LATIN CAPITAL LETTER B",
    "\ue0043": "TAG LATIN CAPITAL LETTER C",
    "\ue0044": "TAG LATIN CAPITAL LETTER D",
    "\ue0045": "TAG LATIN CAPITAL LETTER E",
    "\ue0046": "TAG LATIN CAPITAL LETTER F",
    "\ue0047": "TAG LATIN CAPITAL LETTER G",
    "\ue0048": "TAG LATIN CAPITAL LETTER H",
    "\ue0049": "TAG LATIN CAPITAL LETTER I",
    "\ue004a": "TAG LATIN CAPITAL LETTER J",
    "\ue004b": "TAG LATIN CAPITAL LETTER K",
    "\ue004c": "TAG LATIN CAPITAL LETTER L",
    "\ue004d": "TAG LATIN CAPITAL LETTER M",
    "\ue004e": "TAG LATIN CAPITAL LETTER N",
    "\ue004f": "TAG LATIN CAPITAL LETTER O",
    "\ue0050": "TAG LATIN CAPITAL LETTER P",
    "\ue0051": "TAG LATIN CAPITAL LETTER Q",
    "\ue0052": "TAG LATIN CAPITAL LETTER R",
    "\ue0053": "TAG LATIN CAPITAL LETTER S",
    "\ue0054": "TAG LATIN CAPITAL LETTER T",
    "\ue0055": "TAG LATIN CAPITAL LETTER U",
    "\ue0056": "TAG LATIN CAPITAL LETTER V",
    "\ue0057": "TAG LATIN CAPITAL LETTER W",
    "\ue0058": "TAG LATIN CAPITAL LETTER X",
    "\ue0059": "TAG LATIN CAPITAL LETTER Y",
    "\ue005a": "TAG LATIN CAPITAL LETTER Z",
    "\ue005b": "TAG LEFT SQUARE BRACKET",
    "\ue005c": "TAG REVERSE SOLIDUS",
    "\ue005d": "TAG RIGHT SQUARE BRACKET",
    "\ue005e": "TAG CIRCUMFLEX ACCENT",
    "\ue005f": "TAG LOW LINE",
    "\ue0060": "TAG GRAVE ACCENT",
    "\ue0061": "TAG LATIN SMALL LETTER A",
    "\ue0062": "TAG LATIN SMALL LETTER B",
    "\ue0063": "TAG LATIN SMALL LETTER C",
    "\ue0064": "TAG LATIN SMALL LETTER D",
    "\ue0065": "TAG LATIN SMALL LETTER E",
    "\ue0066": "TAG LATIN SMALL LETTER F",
    "\ue0067": "TAG LATIN SMALL LETTER G",
    "\ue0068": "TAG LATIN SMALL LETTER H",
    "\ue0069": "TAG LATIN SMALL LETTER I",
    "\ue006a": "TAG LATIN SMALL LETTER J",
    "\ue006b": "TAG LATIN SMALL LETTER K",
    "\ue006c": "TAG LATIN SMALL LETTER L",
    "\ue006d": "TAG LATIN SMALL LETTER M",
    "\ue006e": "TAG LATIN SMALL LETTER N",
    "\ue006f": "TAG LATIN SMALL LETTER O",
    "\ue0070": "TAG LATIN SMALL LETTER P",
    "\ue0071": "TAG LATIN SMALL LETTER Q",
    "\ue0072": "TAG LATIN SMALL LETTER R",
    "\ue0073": "TAG LATIN SMALL LETTER S",
    "\ue0074": "TAG LATIN SMALL LETTER T",
    "\ue0075": "TAG LATIN SMALL LETTER U",
    "\ue0076": "TAG LATIN SMALL LETTER V",
    "\ue0077": "TAG LATIN SMALL LETTER W",
    "\ue0078": "TAG LATIN SMALL LETTER X",
    "\ue0079": "TAG LATIN SMALL LETTER Y",
    "\ue007a": "TAG LATIN SMALL LETTER Z",
    "\ue007b": "TAG LEFT CURLY BRACKET",
    "\ue007c": "TAG VERTICAL LINE",
    "\ue007d": "TAG RIGHT CURLY BRACKET",
    "\ue007e": "TAG TILDE",
    "\ue007f": "CANCEL TAG",
    "\ue0100": "VARIATION SELECTOR-17",
    "\ue0101": "VARIATION SELECTOR-18",
    "\ue0102": "VARIATION SELECTOR-19",
    "\ue0103": "VARIATION SELECTOR-20",
    "\ue0104": "VARIATION SELECTOR-21",
    "\ue0105": "VARIATION SELECTOR-22",
    "\ue0106": "VARIATION SELECTOR-23",
    "\ue0107": "VARIATION SELECTOR-24",
    "\ue0108": "VARIATION SELECTOR-25",
    "\ue0109": "VARIATION SELECTOR-26",
    "\ue010a": "VARIATION SELECTOR-27",
    "\ue010b": "VARIATION SELECTOR-28",
    "\ue010c": "VARIATION SELECTOR-29",
    "\ue010d": "VARIATION SELECTOR-30",
    "\ue010e": "VARIATION SELECTOR-31",
    "\ue010f": "VARIATION SELECTOR-32",
    "\ue0110": "VARIATION SELECTOR-33",
    "\ue0111": "VARIATION SELECTOR-34",
    "\ue0112": "VARIATION SELECTOR-35",
    "\ue0113": "VARIATION SELECTOR-36",
    "\ue0114": "VARIATION SELECTOR-37",
    "\ue0115": "VARIATION SELECTOR-38",
    "\ue0116": "VARIATION SELECTOR-39",
    "\ue0117": "VARIATION SELECTOR-40",
    "\ue0118": "VARIATION SELECTOR-41",
    "\ue0119": "VARIATION SELECTOR-42",
    "\ue011a": "VARIATION SELECTOR-43",
    "\ue011b": "VARIATION SELECTOR-44",
    "\ue011c": "VARIATION SELECTOR-45",
    "\ue011d": "VARIATION SELECTOR-46",
    "\ue011e": "VARIATION SELECTOR-47",
    "\ue011f": "VARIATION SELECTOR-48",
    "\ue0120": "VARIATION SELECTOR-49",
    "\ue0121": "VARIATION SELECTOR-50",
    "\ue0122": "VARIATION SELECTOR-51",
    "\ue0123": "VARIATION SELECTOR-52",
    "\ue0124": "VARIATION SELECTOR-53",
    "\ue0125": "VARIATION SELECTOR-54",
    "\ue0126": "VARIATION SELECTOR-55",
    "\ue0127": "VARIATION SELECTOR-56",
    "\ue0128": "VARIATION SELECTOR-57",
    "\ue0129": "VARIATION SELECTOR-58",
    "\ue012a": "VARIATION SELECTOR-59",
    "\ue012b": "VARIATION SELECTOR-60",
    "\ue012c": "VARIATION SELECTOR-61",
    "\ue012d": "VARIATION SELECTOR-62",
    "\ue012e": "VARIATION SELECTOR-63",
    "\ue012f": "VARIATION SELECTOR-64",
    "\ue0130": "VARIATION SELECTOR-65",
    "\ue0131": "VARIATION SELECTOR-66",
    "\ue0132": "VARIATION SELECTOR-67",
    "\ue0133": "VARIATION SELECTOR-68",
    "\ue0134": "VARIATION SELECTOR-69",
    "\ue0135": "VARIATION SELECTOR-70",
    "\ue0136": "VARIATION SELECTOR-71",
    "\ue0137": "VARIATION SELECTOR-72",
    "\ue0138": "VARIATION SELECTOR-73",
    "\ue0139": "VARIATION SELECTOR-74",
    "\ue013a": "VARIATION SELECTOR-75",
    "\ue013b": "VARIATION SELECTOR-76",
    "\ue013c": "VARIATION SELECTOR-77",
    "\ue013d": "VARIATION SELECTOR-78",
    "\ue013e": "VARIATION SELECTOR-79",
    "\ue013f": "VARIATION SELECTOR-80",
    "\ue0140": "VARIATION SELECTOR-81",
    "\ue0141": "VARIATION SELECTOR-82",
    "\ue0142": "VARIATION SELECTOR-83",
    "\ue0143": "VARIATION SELECTOR-84",
    "\ue0144": "VARIATION SELECTOR-85",
    "\ue0145": "VARIATION SELECTOR-86",
    "\ue0146": "VARIATION SELECTOR-87",
    "\ue0147": "VARIATION SELECTOR-88",
    "\ue0148": "VARIATION SELECTOR-89",
    "\ue0149": "VARIATION SELECTOR-90",
    "\ue014a": "VARIATION SELECTOR-91",
    "\ue014b": "VARIATION SELECTOR-92",
    "\ue014c": "VARIATION SELECTOR-93",
    "\ue014d": "VARIATION SELECTOR-94",
    "\ue014e": "VARIATION SELECTOR-95",
    "\ue014f": "VARIATION SELECTOR-96",
    "\ue0150": "VARIATION SELECTOR-97",
    "\ue0151": "VARIATION SELECTOR-98",
    "\ue0152": "VARIATION SELECTOR-99",
    "\ue0153": "VARIATION SELECTOR-100",
    "\ue0154": "VARIATION SELECTOR-101",
    "\ue0155": "VARIATION SELECTOR-102",
    "\ue0156": "VARIATION SELECTOR-103",
    "\ue0157": "VARIATION SELECTOR-104",
    "\ue0158": "VARIATION SELECTOR-105",
    "\ue0159": "VARIATION SELECTOR-106",
    "\ue015a": "VARIATION SELECTOR-107",
    "\ue015b": "VARIATION SELECTOR-108",
    "\ue015c": "VARIATION SELECTOR-109",
    "\ue015d": "VARIATION SELECTOR-110",
    "\ue015e": "VARIATION SELECTOR-111",
    "\ue015f": "VARIATION SELECTOR-112",
    "\ue0160": "VARIATION SELECTOR-113",
    "\ue0161": "VARIATION SELECTOR-114",
    "\ue0162": "VARIATION SELECTOR-115",
    "\ue0163": "VARIATION SELECTOR-116",
    "\ue0164": "VARIATION SELECTOR-117",
    "\ue0165": "VARIATION SELECTOR-118",
    "\ue0166": "VARIATION SELECTOR-119",
    "\ue0167": "VARIATION SELECTOR-120",
    "\ue0168": "VARIATION SELECTOR-121",
    "\ue0169": "VARIATION SELECTOR-122",
    "\ue016a": "VARIATION SELECTOR-123",
    "\ue016b": "VARIATION SELECTOR-124",
    "\ue016c": "VARIATION SELECTOR-125",
    "\ue016d": "VARIATION SELECTOR-126",
    "\ue016e": "VARIATION SELECTOR-127",
    "\ue016f": "VARIATION SELECTOR-128",
    "\ue0170": "VARIATION SELECTOR-129",
    "\ue0171": "VARIATION SELECTOR-130",
    "\ue0172": "VARIATION SELECTOR-131",
    "\ue0173": "VARIATION SELECTOR-132",
    "\ue0174": "VARIATION SELECTOR-133",
    "\ue0175": "VARIATION SELECTOR-134",
    "\ue0176": "VARIATION SELECTOR-135",
    "\ue0177": "VARIATION SELECTOR-136",
    "\ue0178": "VARIATION SELECTOR-137",
    "\ue0179": "VARIATION SELECTOR-138",
    "\ue017a": "VARIATION SELECTOR-139",
    "\ue017b": "VARIATION SELECTOR-140",
    "\ue017c": "VARIATION SELECTOR-141",
    "\ue017d": "VARIATION SELECTOR-142",
    "\ue017e": "VARIATION SELECTOR-143",
    "\ue017f": "VARIATION SELECTOR-144",
    "\ue0180": "VARIATION SELECTOR-145",
    "\ue0181": "VARIATION SELECTOR-146",
    "\ue0182": "VARIATION SELECTOR-147",
    "\ue0183": "VARIATION SELECTOR-148",
    "\ue0184": "VARIATION SELECTOR-149",
    "\ue0185": "VARIATION SELECTOR-150",
    "\ue0186": "VARIATION SELECTOR-151",
    "\ue0187": "VARIATION SELECTOR-152",
    "\ue0188": "VARIATION SELECTOR-153",
    "\ue0189": "VARIATION SELECTOR-154",
    "\ue018a": "VARIATION SELECTOR-155",
    "\ue018b": "VARIATION SELECTOR-156",
    "\ue018c": "VARIATION SELECTOR-157",
    "\ue018d": "VARIATION SELECTOR-158",
    "\ue018e": "VARIATION SELECTOR-159",
    "\ue018f": "VARIATION SELECTOR-160",
    "\ue0190": "VARIATION SELECTOR-161",
    "\ue0191": "VARIATION SELECTOR-162",
    "\ue0192": "VARIATION SELECTOR-163",
    "\ue0193": "VARIATION SELECTOR-164",
    "\ue0194": "VARIATION SELECTOR-165",
    "\ue0195": "VARIATION SELECTOR-166",
    "\ue0196": "VARIATION SELECTOR-167",
    "\ue0197": "VARIATION SELECTOR-168",
    "\ue0198": "VARIATION SELECTOR-169",
    "\ue0199": "VARIATION SELECTOR-170",
    "\ue019a": "VARIATION SELECTOR-171",
    "\ue019b": "VARIATION SELECTOR-172",
    "\ue019c": "VARIATION SELECTOR-173",
    "\ue019d": "VARIATION SELECTOR-174",
    "\ue019e": "VARIATION SELECTOR-175",
    "\ue019f": "VARIATION SELECTOR-176",
    "\ue01a0": "VARIATION SELECTOR-177",
    "\ue01a1": "VARIATION SELECTOR-178",
    "\ue01a2": "VARIATION SELECTOR-179",
    "\ue01a3": "VARIATION SELECTOR-180",
    "\ue01a4": "VARIATION SELECTOR-181",
    "\ue01a5": "VARIATION SELECTOR-182",
    "\ue01a6": "VARIATION SELECTOR-183",
    "\ue01a7": "VARIATION SELECTOR-184",
    "\ue01a8": "VARIATION SELECTOR-185",
    "\ue01a9": "VARIATION SELECTOR-186",
    "\ue01aa": "VARIATION SELECTOR-187",
    "\ue01ab": "VARIATION SELECTOR-188",
    "\ue01ac": "VARIATION SELECTOR-189",
    "\ue01ad": "VARIATION SELECTOR-190",
    "\ue01ae": "VARIATION SELECTOR-191",
    "\ue01af": "VARIATION SELECTOR-192",
    "\ue01b0": "VARIATION SELECTOR-193",
    "\ue01b1": "VARIATION SELECTOR-194",
    "\ue01b2": "VARIATION SELECTOR-195",
    "\ue01b3": "VARIATION SELECTOR-196",
    "\ue01b4": "VARIATION SELECTOR-197",
    "\ue01b5": "VARIATION SELECTOR-198",
    "\ue01b6": "VARIATION SELECTOR-199",
    "\ue01b7": "VARIATION SELECTOR-200",
    "\ue01b8": "VARIATION SELECTOR-201",
    "\ue01b9": "VARIATION SELECTOR-202",
    "\ue01ba": "VARIATION SELECTOR-203",
    "\ue01bb": "VARIATION SELECTOR-204",
    "\ue01bc": "VARIATION SELECTOR-205",
    "\ue01bd": "VARIATION SELECTOR-206",
    "\ue01be": "VARIATION SELECTOR-207",
    "\ue01bf": "VARIATION SELECTOR-208",
    "\ue01c0": "VARIATION SELECTOR-209",
    "\ue01c1": "VARIATION SELECTOR-210",
    "\ue01c2": "VARIATION SELECTOR-211",
    "\ue01c3": "VARIATION SELECTOR-212",
    "\ue01c4": "VARIATION SELECTOR-213",
    "\ue01c5": "VARIATION SELECTOR-214",
    "\ue01c6": "VARIATION SELECTOR-215",
    "\ue01c7": "VARIATION SELECTOR-216",
    "\ue01c8": "VARIATION SELECTOR-217",
    "\ue01c9": "VARIATION SELECTOR-218",
    "\ue01ca": "VARIATION SELECTOR-219",
    "\ue01cb": "VARIATION SELECTOR-220",
    "\ue01cc": "VARIATION SELECTOR-221",
    "\ue01cd": "VARIATION SELECTOR-222",
    "\ue01ce": "VARIATION SELECTOR-223",
    "\ue01cf": "VARIATION SELECTOR-224",
    "\ue01d0": "VARIATION SELECTOR-225",
    "\ue01d1": "VARIATION SELECTOR-226",
    "\ue01d2": "VARIATION SELECTOR-227",
    "\ue01d3": "VARIATION SELECTOR-228",
    "\ue01d4": "VARIATION SELECTOR-229",
    "\ue01d5": "VARIATION SELECTOR-230",
    "\ue01d6": "VARIATION SELECTOR-231",
    "\ue01d7": "VARIATION SELECTOR-232",
    "\ue01d8": "VARIATION SELECTOR-233",
    "\ue01d9": "VARIATION SELECTOR-234",
    "\ue01da": "VARIATION SELECTOR-235",
    "\ue01db": "VARIATION SELECTOR-236",
    "\ue01dc": "VARIATION SELECTOR-237",
    "\ue01dd": "VARIATION SELECTOR-238",
    "\ue01de": "VARIATION SELECTOR-239",
    "\ue01df": "VARIATION SELECTOR-240",
    "\ue01e0": "VARIATION SELECTOR-241",
    "\ue01e1": "VARIATION SELECTOR-242",
    "\ue01e2": "VARIATION SELECTOR-243",
    "\ue01e3": "VARIATION SELECTOR-244",
    "\ue01e4": "VARIATION SELECTOR-245",
    "\ue01e5": "VARIATION SELECTOR-246",
    "\ue01e6": "VARIATION SELECTOR-247",
    "\ue01e7": "VARIATION SELECTOR-248",
    "\ue01e8": "VARIATION SELECTOR-249",
    "\ue01e9": "VARIATION SELECTOR-250",
    "\ue01ea": "VARIATION SELECTOR-251",
    "\ue01eb": "VARIATION SELECTOR-252",
    "\ue01ec": "VARIATION SELECTOR-253",
    "\ue01ed": "VARIATION SELECTOR-254",
    "\ue01ee": "VARIATION SELECTOR-255",
    "\ue01ef": "VARIATION SELECTOR-256",
}

TRANSLATION_MAP = {
    "\u00b2": "^2",  # Superscript 2 (²)
    "\u00b3": "^3",  # Superscript 3 (³)
    "\u2013": "-",  # En dash (–)
    "\u2014": "-",  # Em dash (—)
    "\u2015": "-",  # Horizontal bar (―)
    "\u2018": "'",  # Left curly single quote (‘)
    "\u2019": "'",  # Right curly single quote (’)
    "\u201c": '"',  # Left curly double quote (“)
    "\u201d": '"',  # Right curly double quote (”)
    "\u2022": "*",  # Bullet (•)
    "\u2026": "...",  # Ellipsis (…)
    "\u2081": "_1",  # Subscript 1 (₁)
    "\u2082": "_2",  # Subscript 2 (₂)
    "\u2212": "-",  # Figure dash (‒)
    "\u2605": "*",  # Star dingbat (★)
}
